searchNodes=[{"ref":"Crux.Gateway.html","title":"Crux.Gateway","type":"module","doc":"Main entry point for Crux.Gateway. This module fits under a supervision tree, see start_link/1 arguments for configuration."},{"ref":"Crux.Gateway.html#child_spec/1","title":"Crux.Gateway.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Crux.Gateway.html#start_link/1","title":"Crux.Gateway.start_link/1","type":"function","doc":"Starts a Crux.Gateway process linked to the current process. Options are either just options/0 or a tuple of options/0 and Supervisor.options/0."},{"ref":"Crux.Gateway.html#t:gateway/0","title":"Crux.Gateway.gateway/0","type":"type","doc":"The gateway reference"},{"ref":"Crux.Gateway.html#t:options/0","title":"Crux.Gateway.options/0","type":"type","doc":"Used to start Crux.Gateway. See start_link/1 Notes: :token can be retrieved from here. :url you can GET from /gateway/bot (or c:Crux.Rest.gateway_bot/0). :shard_count same as :url. Optionally :shards, which has to be a list of numbers and ranges.Examples: [1..3], [1, 2, 3], [1..3, 8, 9] Defaults to 0..shard_count-1. Optionally :presence, which is used for the initial presence of every session.This should be a map with a &quot;game&quot; and &quot;status&quot; key, or a function with an arity of one (the shard id) and returning such a map, or nil for the default.If a function, it will be invoked whenever a shard is about to identify. Defaults to %{&quot;game&quot; =&gt; nil, &quot;status&quot; =&gt; &quot;online&quot;}. Optionally :guild_subscriptions, aids large or generally stateless bots by opting out of several events and less data being sent over the gateway.For more information see Discord Docs and the relevant PR on GitHub. Defaults to true Optionally :dispatcher, which has to be a valid GenStage.Dispatcher or a tuple of one and initial state.See Crux.Gateway.Connection.Producer for more info. Defaults to GenStage.BroadcastDispatcher"},{"ref":"Crux.Gateway.html#t:presence/0","title":"Crux.Gateway.presence/0","type":"type","doc":"Used as initial presence for every session."},{"ref":"Crux.Gateway.Command.html","title":"Crux.Gateway.Command","type":"module","doc":"Builds Gateway Commands.Note: Only the sent ones can be found here. A list of available op codes: OP CodeName 0dispatchreceived only 1heartbeattwo way 2identifysent only 3status_updatesent only 4voice_state_updatesent only 5voice_guild_pingsent only 6resumesent only 7reconnectreceived only 8request_guild_memberssent only 9invalid_sessionreceived only 10helloreceived only 11heartbeat_ackreceived only Gateway Lifecycle Flowchart"},{"ref":"Crux.Gateway.Command.html#heartbeat/1","title":"Crux.Gateway.Command.heartbeat/1","type":"function","doc":"Builds a Heartbeat command. Used to signalize the server that the client is still alive and able to receive messages."},{"ref":"Crux.Gateway.Command.html#identify/1","title":"Crux.Gateway.Command.identify/1","type":"function","doc":"Builds an Identify command. Used to identify the gateway connection and &quot;log in&quot;."},{"ref":"Crux.Gateway.Command.html#request_guild_members/2","title":"Crux.Gateway.Command.request_guild_members/2","type":"function","doc":"Builds a Request Guild Members command. Used to request guild member for a specific guild. Note: This must be sent to the connection handling the guild, not just any connection. The gateway will respond with :GUILD_MEMBER_CHUNK packets until all appropriate members are received."},{"ref":"Crux.Gateway.Command.html#resume/1","title":"Crux.Gateway.Command.resume/1","type":"function","doc":"Builds a Resume command. Used to resume into a session which was unexpectly disconnected and may be resumable."},{"ref":"Crux.Gateway.Command.html#status_update/2","title":"Crux.Gateway.Command.status_update/2","type":"function","doc":"Builds a Status Update command. Used to update the status of the client, including activity."},{"ref":"Crux.Gateway.Command.html#voice_state_update/3","title":"Crux.Gateway.Command.voice_state_update/3","type":"function","doc":"Builds a Voice State Update command. Used to join, switch between, and leave voice channels and/or change self_mute or self_deaf states."},{"ref":"Crux.Gateway.Command.html#t:activity/0","title":"Crux.Gateway.Command.activity/0","type":"type","doc":"Used to set an activity via status_update/2. :type must be a valid Activity Type Note that streaming requires a twitch url pointing to a possible channel!"},{"ref":"Crux.Gateway.Command.html#t:command/0","title":"Crux.Gateway.Command.command/0","type":"type","doc":"Encoded command ready to be sent to the gateway via Crux.Gateway.Connection.send_command/3. If you want to build custom commands, pass :erlang.term_to_binary/1 a map with the keys op and d, and wrap it in a tuple with :binary as first element."},{"ref":"Crux.Gateway.Connection.html","title":"Crux.Gateway.Connection","type":"module","doc":"Module handling the actual connection (shard) to Discord."},{"ref":"Crux.Gateway.Connection.html#send_command/3","title":"Crux.Gateway.Connection.send_command/3","type":"function","doc":"Sends a command to the specified shard. Will be run through a rate limiter which blocks the current process."},{"ref":"Crux.Gateway.Connection.Producer.html","title":"Crux.Gateway.Connection.Producer","type":"module","doc":"Handles dispatching of packets received from the gateway. Every Crux.Gateway.Connection (shard) has its own producer, defaults to GenStage.BroadcastDispatchers. The dispatcher can be overriden via Crux.Gateway.options/0 For more informations regarding Consumers and Producers consult GenStage&#39;s documentation."},{"ref":"Crux.Gateway.Connection.Producer.html#producers/1","title":"Crux.Gateway.Connection.Producer.producers/1","type":"function","doc":"Computes a map of all producer pid/0s keyed by shard_id."}]